#!/usr/bin/env python
"""
Name: ChIPModule,Systematic discoveray of transcription factors and their cofactors from ChIP-seq data
Author: jun ding
Date: Jan.6,2012
Version: 1.1
"""
import sys
python=sys.executable
print(python)
if sys.version_info[0]==(3):
    import pdb,sys,os,tkinter,tkinter.filedialog
    from tkinter import *
    class App:
                      def __init__(self,parent):
                                             f = Frame(parent)
                                             f.pack()
                                             self.label=Label(f,text="Please input sequences:")
                                             self.label.pack(side=LEFT)
                                             self.button=Button(f,text="open",command=self.file_selector)
                                             self.button.pack(side=LEFT)
                                             self.v = StringVar()
                                             Label(f, textvariable=self.v).pack(side=LEFT)
                                             
                                             
                                                                                      
                      def file_selector(self):
                                             self.fl = tkinter.filedialog.askopenfile(parent=root,title='Choose a file')
                                             
                                             self.v.set(" "+self.fl.name.split('/')[-1])

    class App1:
                      def __init__(self,parent):
                                             f=Frame(parent)
                                             f.pack()
                                             self.label=Label(f,text="Please input motifs (PWMs):")
                                             self.label.pack(side=LEFT)
                                             self.var = IntVar()
                                             R1 = Radiobutton(f, text="default", variable=self.var, value=1)
                                             R1.pack(side=LEFT)
                                             R2 = Radiobutton(f, text="Your PWMs", variable=self.var, value=2,command=self.file_selector)
                                             R2.pack(side=LEFT)
                                             self.v = StringVar()
                                             Label(f, textvariable=self.v).pack(side=LEFT)
                      
                      def file_selector(self):
                                             self.fl = tkinter.filedialog.askopenfile(parent=root,mode='rb',title='Choose a file')
                                             self.v.set(" ok!")

    class App2:
                      def __init__(self,parent):
                                             f=Frame(parent)
                                             f.pack()
                                             self.label=Label(f,text="Please input Lambda file:")
                                             self.label.pack(side=LEFT)
                                             self.var = IntVar()
                                             R1 = Radiobutton(f, text="default", variable=self.var, value=1)
                                             R1.pack(side=LEFT)
                                             R2 = Radiobutton(f, text="Your Lambda file", variable=self.var, value=2,command=self.file_selector)
                                             R2.pack(side=LEFT)
                                             self.v = StringVar()
                                             Label(f, textvariable=self.v).pack(side=LEFT)
                      
                      def file_selector(self):
                                             self.fl = tkinter.filedialog.askopenfile(parent=root,mode='rb',title='Choose a file')
                                             self.v.set(" ok!")
    class App3:
                      def __init__(self,parent):
                                             f=Frame(parent)
                                             f.pack()
                                             self.label=Label(f,text="pattern mining support value(s):")
                                             self.label.pack()
                                             self.entry=Entry(f)
                                             self.entry.pack()
                                             self.label1=Label(f,text="pvalue cutoff for finding (c):")
                                             self.label1.pack()
                                             self.entry1=Entry(f)
                                             self.entry1.pack()
                                             self.label2=Label(f,text="output foder name:")
                                             self.label2.pack()
                                             self.entry2=Entry(f)
                                             self.entry2.pack()
                                             self.label3=Label(f,text="output format:")
                                             self.label3.pack(side=LEFT)
                                             self.var = IntVar()
                                             R1 = Radiobutton(f, text="txt", variable=self.var, value=1)
                                             R1.pack(side=LEFT)
                                             R2 = Radiobutton(f, text="xls", variable=self.var, value=2)
                                             R2.pack(side=LEFT)
                            
											 
                      def file_selector(self):
                                             self.fl = tkinter.filedialog.askopenfile(parent=root,mode='rb',title='Choose a file')
                                             
    class App5:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.var1= IntVar()
                    self.label4=Label(f,text="want the fully detailed motif combinations file?:")
                    self.label4.pack(side=LEFT)
                    R3 = Radiobutton(f, text="Yes", variable=self.var1, value=1)
                    R3.pack(side=LEFT)
                    R4 = Radiobutton(f, text="No", variable=self.var1, value=2)
                    R4.pack(side=LEFT)

    class App4:
                      def __init__(self,parent):
                                             f=Frame(parent)
                                             f.pack()
                                             self.button=Button(f,text="Get motif combinations",command=self.run)
                                             self.button.pack()
                                             self.v = StringVar()
                                             Label(f, textvariable=self.v).pack(side=LEFT)
                      
                      
                      def run(self):
                                             self.v.set('getting CRMs...')
                                             i=input_file.fl.name
                                             o=parameters.entry2.get()
                                             fmt=parameters.var.get()
                                             wd=dmc.var1.get()
                                             s=parameters.entry.get()
                                             c=parameters.entry1.get()
                                             d={1:'txt',2:'xls'}
                                             y={1:'Y',2:'N'}
                                             ms=input_mat.var.get()
                                             ls=input_lam.var.get()
                                             #print('python crm.py -i '+i+' -o '+o+' -m default -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c)
                                             
                                             if ms==1:
                                                                    if ls==1:
                                                                                      os.system(python+' crm.py -i '+i+' -o '+o+' -m default -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c+" "+y[wd])
                                                                                      self.v.set("done!")
                                                                    else:
                                                                                      os.system(python+' crm.py -i '+i+' -o '+o+' -m default -l '+input_lam.fl.name+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                                                                      self.v.set("done!")
                                             else:
                                                                    if ls==1:
                                                                                      os.system(python+' crm.py -i '+i+' -o '+o+' -m '+input_mat.fl.name+' -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c+"- d "+y[wd])
                                                                                      self.v.set("done!")
                                                                    else:
                                                                                      os.system(python+' crm.py -i '+i+' -o '+o+' -m '+input_mat.fl.name+' -l '+input_lam.fl.name+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                                                                      self.v.set("done!")            
    root = Tk()
    root.title('ChIPModule')
    root.geometry("400x300")
    input_file=App(root)
    input_mat=App1(root)
    input_lam=App2(root)
    parameters=App3(root)
    run=App4(root)

    #pdb.set_trace()
    root.mainloop()

elif sys.version_info[0]==(2):
    import pdb,sys,os,Tkinter,tkFileDialog
    from Tkinter import *
    class App:
        def __init__(self,parent):
            f = Frame(parent)
            f.pack()
            self.label=Label(f,text="Please input sequences:")
            self.label.pack(side=LEFT)
            self.button=Button(f,text="open",command=self.file_selector)
            self.button.pack(side=LEFT)
            self.v = StringVar()
            Label(f, textvariable=self.v).pack(side=LEFT)
            
            
                    
        def file_selector(self):
            self.fl = tkFileDialog.askopenfile(parent=root,title='Choose a file')
            
            self.v.set(" "+self.fl.name.split('/')[-1])

    class App1:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.label=Label(f,text="Please input motifs (PWMs):")
                    self.label.pack(side=LEFT)
                    self.var = IntVar()
                    R1 = Radiobutton(f, text="default", variable=self.var, value=1)
                    R1.pack(side=LEFT)
                    R2 = Radiobutton(f, text="Your PWMs", variable=self.var, value=2,command=self.file_selector)
                    R2.pack(side=LEFT)
                    self.v = StringVar()
                    Label(f, textvariable=self.v).pack(side=LEFT)
            
            def file_selector(self):
                    self.fl = tkFileDialog.askopenfile(parent=root,mode='rb',title='Choose a file')
                    self.v.set(" ok!")

    class App2:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.label=Label(f,text="Please input Lambda file:")
                    self.label.pack(side=LEFT)
                    self.var = IntVar()
                    R1 = Radiobutton(f, text="default", variable=self.var, value=1)
                    R1.pack(side=LEFT)
                    R2 = Radiobutton(f, text="Your Lambda file", variable=self.var, value=2,command=self.file_selector)
                    R2.pack(side=LEFT)
                    self.v = StringVar()
                    Label(f, textvariable=self.v).pack(side=LEFT)
            
            def file_selector(self):
                    self.fl = tkFileDialog.askopenfile(parent=root,mode='rb',title='Choose a file')
                    self.v.set(" ok!")
    class App3:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.label=Label(f,text="pattern mining support value(s):")
                    self.label.pack()
                    self.entry=Entry(f)
                    self.entry.pack()
                    self.label1=Label(f,text="pvalue cutoff for finding CRMs(c):")
                    self.label1.pack()
                    self.entry1=Entry(f)
                    self.entry1.pack()
                    self.label2=Label(f,text="output foder name:")
                    self.label2.pack()
                    self.entry2=Entry(f)
                    self.entry2.pack()
                    self.label3=Label(f,text="output format:")
                    self.label3.pack(side=LEFT)
                    self.var = IntVar()
                    R1 = Radiobutton(f, text="txt", variable=self.var, value=1)
                    R1.pack(side=LEFT)
                    R2 = Radiobutton(f, text="xls", variable=self.var, value=2)
                    R2.pack(side=LEFT)
            def file_selector(self):
                    self.fl = tkFileDialog.askdirectory(parent=root,mode='rb',title='Choose a file')
          
    class App5:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.var1= IntVar()
                    self.label4=Label(f,text="want the fully detailed motif combinations file?:")
                    self.label4.pack(side=LEFT)
                    R3 = Radiobutton(f, text="Yes", variable=self.var1, value=1)
                    R3.pack(side=LEFT)
                    R4 = Radiobutton(f, text="No", variable=self.var1, value=2)
                    R4.pack(side=LEFT)
            
    class App4:
            def __init__(self,parent):
                    f=Frame(parent)
                    f.pack()
                    self.button=Button(f,text="Get motif combinations",command=self.run)
                    self.button.pack()
                    self.v = StringVar()
                    Label(f, textvariable=self.v).pack(side=LEFT)   
            
            def run(self):
                    self.v.set('getting CRMs...')
                    i=input_file.fl.name
                    o=parameters.entry2.get()
                    fmt=parameters.var.get()
                    wd=dmc.var1.get()
                    s=parameters.entry.get()
                    c=parameters.entry1.get()
                    
                    d={1:'txt',2:'xls'}
                    y={1:'Y',2:'N'}
                    ms=input_mat.var.get()
                    ls=input_lam.var.get()
                    
                    #print('python crm.py -i '+i+' -o '+o+' -m default -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c)
                    
                    if ms==1:
                            if ls==1:
                                    os.system(python+' crm.py -i '+i+' -o '+o+' -m default -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                    self.v.set("done!")
                            else:
                                    os.system(python+' crm.py -i '+i+' -o '+o+' -m default -l '+input_lam.fl.name+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                    self.v.set("done!")
                    else:
                            if ls==1:
                                    os.system(python+' crm.py -i '+i+' -o '+o+' -m '+input_mat.fl.name+' -l default'+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                    self.v.set("done!")
                            else:
                                    os.system(python+' crm.py -i '+i+' -o '+o+' -m '+input_mat.fl.name+' -l '+input_lam.fl.name+' -f '+d[fmt]+' -s '+s+' -c '+c+" -d "+y[wd])
                                    self.v.set("done!")     
                                            
    root = Tk()
    root.title('ChIPModule')
    root.geometry("400x300")
    input_file=App(root)
    input_mat=App1(root)
    input_lam=App2(root)
    parameters=App3(root)
    dmc=App5(root)
    run=App4(root)
    root.mainloop()
      
else:
    print("Error! Please use python2.x or python3.x!")
    
    
